//************************************************************************//
//									  //
//  Copyright 2013 Bertram Kopf (bertram@ep1.rub.de)			  //
//  	      	   Julian Pychy (julian@ep1.rub.de)			  //
//          	   - Ruhr-Universität Bochum 				  //
//									  //
//  This file is part of Pawian.					  //
//									  //
//  Pawian is free software: you can redistribute it and/or modify	  //
//  it under the terms of the GNU General Public License as published by  //
//  the Free Software Foundation, either version 3 of the License, or 	  //
//  (at your option) any later version.	 	      	  	   	  //
//									  //
//  Pawian is distributed in the hope that it will be useful,		  //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of	  //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	  //
//  GNU General Public License for more details.	      		  //
//									  //
//  You should have received a copy of the GNU General Public License     //
//  along with Pawian.  If not, see <http://www.gnu.org/licenses/>.	  //
//									  //
//************************************************************************//

// AbsParamHandler class definition file. -*- C++ -*-
// Copyright 2012 Bertram Kopf

#pragma once

#include <iostream>
#include <memory>

#include "PwaUtils/EvtDataBaseList.hh"
#include "FitParams/FitParColBase.hh"

class AbsParamHandler {

public:
  AbsParamHandler();
  virtual ~AbsParamHandler();

  virtual void getDefaultParams(fitParCol& fitVal, fitParCol& fitErr)=0;
  virtual bool checkRecalculation(fitParCol& theParamVal)=0;
  virtual void cacheAmplitudes()=0;
  virtual void updateFitParams(fitParCol& theParamVal)=0;
  static bool CheckDoubleEquality(double a, double b);

protected:
  bool _cacheAmps;
  bool _recalculate;

private:

};
